package mosaic.sim.contBlocks;

import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.continuous.*;
import mosaic.sim.kernel.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.ArrayList;
import javax.swing.JLabel;


/** Implements the Productolute value. */
public class Product extends AbstractContEquation{
   ArrayList factors=new ArrayList(10);
   ArrayList localFactors=new ArrayList(10);
   DoubleVariable[] tenFactors=new DoubleVariable[10];
   double[] tenLocalFactors={1,1,1,1,1,1,1,1,1,1};
   DoubleVariable output;
   JLabel la;
   public Product() {
      super();
      initPaint();
      } // Product;

   public Product(String name) {
      super(name);
      initPaint();
      } // Product


/*   public Product(DoubleVariable input,DoubleVariable output){
      super();
      initPaint();
      setInput(input);
      setOutput(output);
      } // Product;

   public Product(String name,DoubleVariable input,DoubleVariable output){
      super(name);
      initPaint();
      setInput(input);
      setOutput(output);
      } // Product

   public Product(ModelComponent parent, String name,DoubleVariable input,DoubleVariable output){
      super(parent, name);
      initPaint();
      setInput(input);
      setOutput(output);
      } // Product

   public Product(ModelComponent parent,DoubleVariable input,DoubleVariable output){
      super(parent);
      initPaint();
      setInput(input);
      setOutput(output);
      } // Product
*/

  protected void initPaint(){
    la=new JLabel();
    la.setFont(new java.awt.Font("Dialog", 1, 10));
    la.setForeground(Color.black);
    la.setOpaque(false);
  }

  public void addFactor(DoubleVariable factor){
    addFactor(factor,1);
  }

  /** Set the input variable. */
  public void addFactor(DoubleVariable factor,double localFactor){
    if (factor==null) return;
    if (factors.contains(factor)) return;
    factors.add(factor);
    localFactors.add(new Double(localFactor));
    DoubleVariable domain[]=new DoubleVariable[factors.size()];
    for (int i=0;i<factors.size();i++) domain[i]=(DoubleVariable)factors.get(i);
    try{
      setDomains(domain);
    } catch(VariableException e){printErrorOutput(e.getMessage());}
  }

  /** Set the output variable. */
  public void setOutput(DoubleVariable output){
    this.output=output;
    try{
      setTargets(new DoubleVariable[]{output});
    } catch(VariableException e){printErrorOutput(e.getMessage());}
  }

  /** Returns the input variable. */
  public ArrayList getFactors(){
    return factors;
  }

  public double getLocalFactor(DoubleVariable factor){
    if (factor==null) return Double.NaN;
    int pos=factors.indexOf(factor);
    if (pos<0) return Double.NaN;
    Double f=(Double)localFactors.get(pos);
    return f.doubleValue();
  }

  public void setLocalFactor(DoubleVariable factor,double localFactor){
    if (factor==null) return;
    int pos=factors.indexOf(factor);
    if (pos<0) return;
    localFactors.set(pos,new Double(localFactor));
    changeOneOfTenLoc(factor,localFactor);
  }

  public void removeFactor(DoubleVariable factor){
    if (factor==null) return;
    int pos=factors.indexOf(factor);
    if (pos<0) return;
    factors.remove(pos);
    localFactors.remove(pos);
    remOneOfTen(factor);
  }

  protected void remOneOfTen(DoubleVariable factor){
    for (int i=0;i<10;i++){
      if (tenFactors[i]==factor) tenFactors[i]=null;
    }
  }

  protected void changeOneOfTenLoc(DoubleVariable factor,double localFactor){
    for (int i=0;i<10;i++){
      if (tenFactors[i]==factor) tenLocalFactors[i]=localFactor;
    }
  }

/*-- new factor  -----*/
  public void setFactor01(DoubleVariable factor){
    removeFactor(tenFactors[0]);
    tenFactors[0]=factor;
    addFactor(factor,tenLocalFactors[0]);
  }

  public DoubleVariable getFactor01(){
    return tenFactors[0];
  }

  public void setFactor01Factor(double localFactor){
    tenLocalFactors[0]=localFactor;
    setLocalFactor(tenFactors[0],localFactor);
  }

  public double getFactor01Factor(){
    return tenLocalFactors[0];
  }

/*-- new factor  -----*/
  public void setFactor02(DoubleVariable factor){
    removeFactor(tenFactors[1]);
    tenFactors[1]=factor;
    addFactor(factor,tenLocalFactors[1]);
  }

  public DoubleVariable getFactor02(){
    return tenFactors[1];
  }

  public void setFactor02Factor(double localFactor){
    tenLocalFactors[1]=localFactor;
    setLocalFactor(tenFactors[1],localFactor);
  }

  public double getFactor02Factor(){
    return tenLocalFactors[1];
  }

/*-- new factor  -----*/
  public void setFactor03(DoubleVariable factor){
    removeFactor(tenFactors[2]);
    tenFactors[2]=factor;
    addFactor(factor,tenLocalFactors[2]);
  }

  public DoubleVariable getFactor03(){
    return tenFactors[2];
  }

  public void setFactor03Factor(double localFactor){
    tenLocalFactors[2]=localFactor;
    setLocalFactor(tenFactors[2],localFactor);
  }

  public double getFactor03Factor(){
    return tenLocalFactors[2];
  }

/*-- new factor  -----*/
  public void setFactor04(DoubleVariable factor){
    removeFactor(tenFactors[3]);
    tenFactors[3]=factor;
    addFactor(factor,tenLocalFactors[3]);
  }

  public DoubleVariable getFactor04(){
    return tenFactors[3];
  }

  public void setFactor04Factor(double localFactor){
    tenLocalFactors[3]=localFactor;
    setLocalFactor(tenFactors[3],localFactor);
  }

  public double getFactor04Factor(){
    return tenLocalFactors[3];
  }

/*-- new factor  -----*/
  public void setFactor05(DoubleVariable factor){
    removeFactor(tenFactors[4]);
    tenFactors[4]=factor;
    addFactor(factor,tenLocalFactors[4]);
  }

  public DoubleVariable getFactor05(){
    return tenFactors[4];
  }

  public void setFactor05Factor(double localFactor){
    tenLocalFactors[4]=localFactor;
    setLocalFactor(tenFactors[4],localFactor);
  }

  public double getFactor05Factor(){
    return tenLocalFactors[4];
  }

/*-- new factor  -----*/
  public void setFactor06(DoubleVariable factor){
    removeFactor(tenFactors[5]);
    tenFactors[5]=factor;
    addFactor(factor,tenLocalFactors[5]);
  }

  public DoubleVariable getFactor06(){
    return tenFactors[5];
  }

  public void setFactor06Factor(double localFactor){
    tenLocalFactors[5]=localFactor;
    setLocalFactor(tenFactors[5],localFactor);
  }

  public double getFactor06Factor(){
    return tenLocalFactors[5];
  }

/*-- new factor  -----*/
  public void setFactor07(DoubleVariable factor){
    removeFactor(tenFactors[6]);
    tenFactors[6]=factor;
    addFactor(factor,tenLocalFactors[6]);
  }

  public DoubleVariable getFactor07(){
    return tenFactors[6];
  }

  public void setFactor07Factor(double localFactor){
    tenLocalFactors[6]=localFactor;
    setLocalFactor(tenFactors[6],localFactor);
  }

  public double getFactor07Factor(){
    return tenLocalFactors[6];
  }

/*-- new factor  -----*/
  public void setFactor08(DoubleVariable factor){
    removeFactor(tenFactors[7]);
    tenFactors[7]=factor;
    addFactor(factor,tenLocalFactors[7]);
  }

  public DoubleVariable getFactor08(){
    return tenFactors[7];
  }

  public void setFactor08Factor(double localFactor){
    tenLocalFactors[7]=localFactor;
    setLocalFactor(tenFactors[7],localFactor);
  }

  public double getFactor08Factor(){
    return tenLocalFactors[7];
  }

/*-- new factor  -----*/
  public void setFactor09(DoubleVariable factor){
    removeFactor(tenFactors[8]);
    tenFactors[8]=factor;
    addFactor(factor,tenLocalFactors[8]);
  }

  public DoubleVariable getFactor09(){
    return tenFactors[8];
  }

  public void setFactor09Factor(double localFactor){
    tenLocalFactors[8]=localFactor;
    setLocalFactor(tenFactors[8],localFactor);
  }

  public double getFactor09Factor(){
    return tenLocalFactors[8];
  }

/*-- new factor  -----*/
  public void setFactor10(DoubleVariable factor){
    removeFactor(tenFactors[9]);
    tenFactors[9]=factor;
    addFactor(factor,tenLocalFactors[9]);
  }

  public DoubleVariable getFactor10(){
    return tenFactors[9];
  }

  public void setFactor10Factor(double localFactor){
    tenLocalFactors[9]=localFactor;
    setLocalFactor(tenFactors[9],localFactor);
  }

  public double getFactor10Factor(){
    return tenLocalFactors[9];
  }


  /** Returns the output variable. */
  public DoubleVariable getOutput(){
    return output;
  }

  public void equation(){
    double product=1;
    double localFactor;
    DoubleVariable factor;
    for (int i=0;i<factors.size();i++){
      factor=(DoubleVariable)factors.get(i);
      localFactor=((Double)localFactors.get(i)).doubleValue();
      product=product*(factor.getValue()*localFactor);
    }
    output.setValue(product);
  }

  public void paintComponent(Graphics g) {
    Graphics2D g2=(Graphics2D) g;
    int h = getSize().height-1;
    int w = getSize().width-1;
    int minWH=Math.min(h,w/2);
    int dist=Math.max(h/10,2);

    Color lineC;
    Color fillC;
/*    if (enabled) g.setColor(Color.black);
    else g.setColor(Color.gray);*/
    if (enabled){
      lineC=Color.black;
      fillC=Color.yellow;
    }
    else{
      lineC=Color.gray;
      fillC=Color.lightGray;
    }
    g2.setPaint(fillC);

//    Rectangle r=new Rectangle(w/4,0,w/2,h);
    Ellipse2D e=new Ellipse2D.Double(w/2-minWH/2,h/2-minWH/2,minWH,minWH);
    g2.fill(e);


    g2.setPaint(lineC);

    GeneralPath p=new GeneralPath(GeneralPath.WIND_EVEN_ODD);

    g2.draw(e);

    p.moveTo(0,h/2+dist);
    p.lineTo(0,h/2-dist);
    p.lineTo(w/2-minWH/2-dist*2,h/2-dist);
    p.lineTo(w/2-minWH/2-dist*2,h/2-dist*2);
    p.lineTo(w/2-minWH/2,h/2);
    p.lineTo(w/2-minWH/2-dist*2,h/2+dist*2);
    p.lineTo(w/2-minWH/2-dist*2,h/2+dist);
    p.closePath();
    g2.draw(p);

//    g2.draw(new Line2D.Double(0,h/2+dist,w/2-minWH/2,h/2+dist));
//    g2.draw(new Line2D.Double(0,h/2-dist,w/2-minWH/2,h/2-dist));

//    g2.draw(new Line2D.Double(0,h/2,w/2-minWH/2,h/2));
    g2.draw(new Line2D.Double(w/2+minWH/2,h/2,w,h/2));

//    la.setBounds((x1+x2)/2+5,(y1+y2)/2-10,(int)la.getPreferredSize().getWidth(),(int)la.getPreferredSize().getHeight());
    la.setHorizontalAlignment(la.CENTER);
    la.setVerticalAlignment(la.CENTER);

    la.setBounds(e.getBounds());
    Graphics2D g3=(Graphics2D)g2.create(w/2-minWH/2,h/2-minWH/2,minWH,minWH);
    la.setText("PROD");
    la.paint(g3);

    String input="";
    for (int i=0;i<factors.size();i++){
      input=input+((DoubleVariable)factors.get(i)).getLabel();
      if (i!=(factors.size()-1)) input=input+"*";
    }

    if (factors.size()>0){
      la.setBounds(0,0,w/2-minWH/2,h/2-dist);
      la.setText(input);
      la.setFont(new java.awt.Font("Dialog", 0, 10));
      la.setVerticalAlignment(la.BOTTOM);
      la.setHorizontalAlignment(la.LEFT);
      g3=(Graphics2D)g2.create(0,0,w/2-minWH/2,h/2-dist);
      la.paint(g3);
    }

    if (output!=null){
      la.setBounds(w/2+minWH/2,0,w/2-minWH/2,h/2);
      la.setText(output.getLabel());
      la.setHorizontalAlignment(la.RIGHT);
      g3=(Graphics2D)g2.create(w/2+minWH/2,0,w/2-minWH/2,h/2);
//      if (input==null){
        la.setFont(new java.awt.Font("Dialog", 0, 10));
        la.setVerticalAlignment(la.BOTTOM);
//      }
      la.paint(g3);
    }

  }

  public Dimension getPreferredSize() {
    return new Dimension(60,35);
  }


}