/**
 * Project mosaic
 *
 * AttachableSimulationPanel.java
 *
 * copyright 2000, JKU Linz, Austria
 */
package mosaic.sim.kernel;

/**
 * A specialization of ModelPanel to allow attachment and detachment of this panel.
 * Used together with TabbedMainFrame.
 * Should be used as a superclass for Simulation panels which allow to attach and detach
 * from the simulation. Attach and Detach should be specialized to implement the attachment
 * and detachment of the components from the simulation application.
 */
public class AttachableModelPanel extends ModelPanel{
    public AttachableModelPanel(){
        super();
    }

    // defines two new methods to allow dynamic attach and
    // remove to simulation variables

    boolean attached = false;

    /** Attach this panel and all contained components from the simulation model.
     * Should be specialized in subclasses.
     */
    public void attach() {  }
    /** Attach this panel and all contained components from the simulation model.
     * Should be specialized.
     */
    public void detach() {  }
} 