/**
 * Project mosaic
 *
 * SimException.java
 *
 * copyright 2000, JKU Linz, Austria
 *
 */

package mosaic.sim.kernel;

import java.lang.*;

/**
 * Exception class for all exceptions which occur in the simulation.
 */
public abstract class SimException extends Exception {

   /**
   * Creates a Exception object with fixed error message.
   */
   public SimException()
      { super("unknown continuous simulation exception"); }

   /**
   * Creates a Exception object with error message message.
   * @param s error message
   */
   public SimException(String message)
      { super(message); }

} // end SimException

