package mosaic.sim.kernel.continuous;

/**
* Diese Ausnahmebedingung zeigt eine algebraische Schleife im erzeugten Modell
* an. Dies kann einerseits bedeuten, da die Abhngigheit der Eingabe- und
* Ausgabevariablen zyklisch ist, oder da ein Moore-Modell als Mealy-Modell
* gekennzeichnet ist und somit die Abhngigkeit der Modelle nicht bestimmt werden
* kann.
*/

public class CSEAlgebraicCycle
   extends ContSimulationException
   {
   /**
   * Erzeugt eine Instanz dieser Klasse mit fixem Fehlertext.
   */
   public CSEAlgebraicCycle()
      { this("model contains algebraic cycle"); }

   /**
   * Erzeugt eine Instanz der Klasse mit bergebenem Fehlertext.
   * @param s Fehlertext der Ausnahmebedingung
   */
   public CSEAlgebraicCycle(String s)
      { super(s); }
   } // class CSEAlgebraicCycle

// end of CSEAlgebraicCycle.java
