package mosaic.sim.kernel.continuous;

import mosaic.sim.kernel.*;
import mosaic.sim.kernel.variable.*;

/**
*  Interface for equations of continuous models.
*/
public interface ContEquation extends Coupler {

   /**
   *  Tests if the equation is enabled.
   */
   public boolean isEnabled();

   /*
   * Get the domain variables of the equation
   */
   public Variable[] getDomain ();

   /*
   * Get the target variables of the equation
   */
   public Variable[] getTarget ();



   /**
   *  Method to implement the continuous equation.
   */
   public void equation()
      throws ContSimulationException;

}
