package mosaic.sim.kernel.continuous;

import java.lang.*;
import java.util.*;
import java.lang.reflect.*;
import mosaic.sim.kernel.*; 
/**
* Diese Klasse implementiert die mathematische Integrationsmethode von Euler. Es
* ist ein sehr simples Verfahren und dadurch sehr schnell, allerdings die Fehler
* beim integrieren knnen sehr stark abweichen, wenn die Funktion sehr kompliziert
* ist.
*/

public class Euler
   extends BasicIntegrationMethod
   {

   /**
   * Erzeugt eine Instanz der Klasse.
   */
   public Euler()
      { super(); }

   /**
   * Fhrt einen Integrationsschritt aus.
   */
   public void integrationStep(double currTime, double stepWidth)
      throws ContSimulationException {

      // compute next state
      for(int i = 0; i < nrStates; i++) {
         oldStates[i] = states[i].getValue();
         states[i].setValue(oldStates[i] + stepWidth * states[i].getDerivative().getValue());
         states[i].setChangedTime(currTime + stepWidth);
      }

      // compute all variables
      doEquations();

   } // integrationStep

} // class Euler


// end of Euler.java
