package mosaic.sim.kernel.continuous;

import mosaic.sim.kernel.*;
import mosaic.sim.kernel.simevent.*;

/**
* Interface which must be supported by all components which signal state events.
*/

public interface StateEventComponent
   extends SimEventComponent
   {
   /**
   * Checks the guard, if the event has to be triggered.
   */
   public boolean eventOccured();
    
   /**
   * Add StateEventListener
   */
   public void addStateEventListener(StateEventListener stateEventListener);

	 /**
   * Remove StateEventListener
   */
   public void removeStateEventListener(StateEventListener stateEventListener);
   } // interface StateEventComponent

// end of StateEventComponent.java

