package mosaic.sim.kernel.continuous;

import java.util.*;
import mosaic.sim.kernel.*;
import mosaic.sim.kernel.variable.*;

/**
*   enabling added by Alice 24.11.98.
*
* Class implementing a guard for a DoubleVariable variable crossing zero.  to trigger time events.
* <p>
* Implements the interface StateEventComponent.
* <b>Events:</b><p>
* <dl>
* <dt><code>zeroCrossingEvent</code></dt>
* <dd>signals that time of the Timer has passed and a time event should be triggered</dd>
* </dl>
* @see sim.kernel.StateEvent
* @see sim.kernel.StateEventListener
* @see sim.kernel.ModelComponent
*/

public class ZeroCrossingGuard
   extends ValueCrossingGuard
   {

   public ZeroCrossingGuard()
      {
        super();
        setEnabled(true);
      }

   public ZeroCrossingGuard(DoubleVariable real)
   {
      super(real, 0.0);
   }

   public ZeroCrossingGuard(ModelComponent owner, String iLabel, DoubleVariable real)
      { super(owner, iLabel, real, 0.0);
      }

   }
