package mosaic.sim.kernel.control;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 *
 *
 *
 */
public class SchedulingAnalyzerDialog extends JDialog implements ActionListener {
    public SchedulingAnalyzerDialog() {
        super (new Frame(), "SchedulingAnalyzer", false);
        setSize(450, 130);
        getContentPane().setLayout(new GridLayout(4,2));
        timer = new javax.swing.Timer(1000, this);
        avgSleep = new JLabel("");
        avgFrame = new JLabel("");
        avgAnimation = new JLabel("");
        avgFps = new JLabel("");
        stepsPerSec = new JLabel("");
        avgStep = new JLabel("");
        freeMemory = new JLabel("");
        totalMemory = new JLabel("");
        getContentPane().add(avgSleep);
        getContentPane().add(avgFrame);
        getContentPane().add(avgAnimation);
        getContentPane().add(avgFps);
        getContentPane().add(stepsPerSec);
        getContentPane().add(avgStep);
        getContentPane().add(freeMemory);
        getContentPane().add(totalMemory);
        analyzer = SimulationScheduler.getAnalyzer();
    }

    public void setVisible(boolean vis) {
        super.setVisible(vis);
        if (vis)
            timer.start();
        else
            timer.stop();
    }
    //
    // Interface ActionListener
    //
    public void actionPerformed(ActionEvent e) {
        if ((e.getSource() == timer) && (analyzer != null)) {
            avgSleep.setText("avgSleep : " + analyzer.getAvgSleepDuration());
            avgFrame.setText("avgFrame : " + analyzer.getAvgFrameDuration());
            avgAnimation.setText("avgAnim : " + (int)(analyzer.getAvgAnimationDuration() * 1000) / 1000.0);
            avgFps.setText("avgFps : " + analyzer.getAvgFps());
            stepsPerSec.setText("stPerSec : " + analyzer.getStepsPerSecond());
            avgStep.setText ("avgStep : " + (int)(analyzer.getAvgStepDuration() * 1000) / 1000.0);
            freeMemory.setText("memfree : " + Runtime.getRuntime().freeMemory() / 1024.0 / 1024.0);
            totalMemory.setText("total : " + Runtime.getRuntime().totalMemory() / 1024.0 / 1024.0);
        }
        else
            analyzer = SimulationScheduler.getAnalyzer();
    }

    javax.swing.Timer timer;
    SimulationScheduler.SchedulingAnalyzer analyzer;
    JLabel avgSleep, avgFrame, avgAnimation, avgFps, avgStep, freeMemory, totalMemory;
    JLabel stepsPerSec;
}





