
//Title:        Ihr Produktname
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       H. Praehofer
//Company:      Johannes Kepler University Linz
//Description:  Ihre Beschreibung

package mosaic.sim.kernel.output;

import java.beans.*;

public class BackgroundComponentBeanInfo extends SimpleBeanInfo {
  Class beanClass = BackgroundComponent.class;
  String iconColor16x16Filename = "BackgroundComponentC16.gif";
  String iconColor32x32Filename = "BackgroundComponentC32.gif";
  String iconMono16x16Filename = "BackgroundComponentC16.gif";
  String iconMono32x32Filename = "BackgroundComponentC32.gif";

  public BackgroundComponentBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _imageFileName = new PropertyDescriptor("imageFileName", beanClass, "getImageFileName", "setImageFileName");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _imageFileName,};
      return pds;

    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
	    case BeanInfo.ICON_COLOR_16x16:
	      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
	    case BeanInfo.ICON_COLOR_32x32:
	      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
	    case BeanInfo.ICON_MONO_16x16:
	      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
	    case BeanInfo.ICON_MONO_32x32:
	      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
	  }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
}

 