package mosaic.sim.kernel.output;

import java.awt.*;

public class ContVariableView extends VariableView {

// Class is base class for all views to visualize the value of a continuous
// variable (except textRepresentations -> will be done by NumberView)
    public ContVariableView() {
    }

    // directly overwrite paintComponent, to avoid drawing of a background
    // 3D rectangle.
    // Draw label to bottom of component
    public void paintComponent(Graphics g) {
        int height = getHeight();
        int width = getWidth();
        g.setFont(getFont());
        FontMetrics fm = g.getFontMetrics();
        g.drawString(getLabel(), (width - fm.stringWidth(getLabel())) / 2,
                     height - fm.getMaxDescent() -2);
        paintValue(g);
    }

    public void setValue (Object newVal) {
        if (newVal instanceof Double) {
            super.setValue(newVal);
            setDoubleValue(((Double)newVal).doubleValue());
        }
        else
            System.out.println(">> tried to send non Double value to " + toString());
    }

    // Double Object holds actual value from continuous simulation variable
    double doubleVal;

    public void setDoubleValue(double newVal) {
        doubleVal = newVal;
    }

    public double getDoubleValue() {
        return doubleVal;
    }


    // property max ------------------------------------------------------------
    double max = 100;

    public void setMax(double m)
    {   max = m;
    }

    public double getMax()
    {   return max;
    }

    // property min ------------------------------------------------------------
    double min = 0.0;

    public void setMin(double m)
    {   min = m;
    }

    public double getMin()
    {   return min;
    }
}
