
/**
 * ThresholdAlarm.java
 *
 *
 * Created: Wed Nov 24 18:52:43 1999
 *
 * @author Reitinger Bernhard
 * @version
 */
package mosaic.sim.kernel.output;

import mosaic.sim.kernel.*;
import mosaic.sim.kernel.variable.*;

public class ThresholdAlarm extends VariableChangeListenerAlarm  {
    
    private double threshold;
    private boolean alarmOnIncrease;
    private boolean alarmEnabled = false;
    
    public ThresholdAlarm() {
	
    }

    public boolean testCondition(VariableChangeEvent e) {
	Number num = null;

	if (e.getVariable().getValueObject() instanceof Number)
	    num = (Number)((VariableChangeComponent)e.getVariable()).getValueObject();
	else
	    return false;

	if (alarmOnIncrease) {
	    if ((num.doubleValue() > threshold) && (!alarmEnabled))  {
		alarmEnabled = true;
	    } else if (num.doubleValue() <= threshold) {
		alarmEnabled = false;
		return true;
	    }
	} else {                 // alarm on decrease
	    if ((num.doubleValue() < threshold) && (!alarmEnabled))  {
		alarmEnabled = true;
	    } else if (num.doubleValue() >= threshold) {
		alarmEnabled = false;
		return true;
	    }
	}
	return false;
    }
    

    /**
       * Get the value of alarmOnIncrease.
       * @return Value of alarmOnIncrease.
       */
    public boolean getAlarmOnIncrease() {return alarmOnIncrease;}
    
    /**
       * Set the value of alarmOnIncrease.
       * @param v  Value to assign to alarmOnIncrease.
       */
    public void setAlarmOnIncrease(boolean  v) {this.alarmOnIncrease = v;}
    
    /**
       * Get the value of threshold.
       * @return Value of threshold.
       */
    public double getThreshold() {return threshold;}
    
    /**
       * Set the value of threshold.
       * @param v  Value to assign to threshold.
       */
    public void setThreshold(double  v) {this.threshold = v;}
    
    
    
} // ThresholdAlarm
