package mosaic.sim.kernel.statistics;

import java.awt.*;
import java.awt.event.*;

/**
* Window for printing out statistics information from statistics beans
*
* Has and provides a TraceArea where the output can be done.
*
* @author Herbert Praehofer
* @version %I% %G%
*/
public class StatisticsReportWindow
    extends Dialog
{
    TextArea textArea;

  /**
  * Constructor StatisticsReportWindow
  * @param parent     the parent frame window
  * @param title      the title of the window usually with the label of the statistics bean
  * @param istat      the statistics bean
  */
  public StatisticsReportWindow(Frame parent, String title) {
      super (parent, title);
      setLayout (new BorderLayout ());
      textArea = new TextArea ();
      textArea.setFont(new Font ("SansSerif", Font.PLAIN, 10));
      add(BorderLayout.CENTER, textArea);
      addWindowListener (new WindowAdapter() {
          public void windowClosing (WindowEvent evt) {
              textArea.setText("");
              dispose();
          }
      });
  }

  /** the preferred size of the window for the LayoutManager */
  public Dimension getPreferredSize() {
      return (new Dimension (240, 200));
  }

  /** Gets the TraceArea component for the output of the statistics report */
  public TextArea getTextArea () {
      return textArea;
  }
}
