package mosaic.sim.kernel.variable;

import mosaic.sim.kernel.ModelComponent;

/** The basic interface for Connection and ContiuousEquation. */
public interface Coupler extends ModelComponent {
  /* This method is called, when the definedBy Variable is changed. */
  void definedByChange(Variable d);

  /* This method is called, when the variable changes the type. */
  void domainTypeChange(Variable d);

  /* This method is called, when the variable changes the type. */
  void targetTypeChange(Variable t);

  /* This method is called, when the value changes. */
  void propagateValueChange(Variable d);

  /* Returns the current mode. */
  boolean isContinuousMode();

  /* Tells the coupler that the domain got continuous. */
  void domainGotContinuous();

  /* Tells the coupler that the domain got discrete. */
  void domainGotDiscrete();

}

