/*
 *  SetVariable
 *
 * @version 2.0 alpha
 * @date
 *
 * copyright: JKU Linz
 */


package mosaic.sim.kernel.variable;

import java.lang.*;
import java.util.*;

/**
 * Abstract class for all Variables which function like a Set.
 */
abstract public class SetVariable
        extends mosaic.sim.kernel.variable.CollectionVariable  //++ not compatible with Component: implements Set
{

  /** Constructor for SetVariable initializing model owner, name,
  * description, unit of measurement, quantity, displayUnit, variable type. */
  public SetVariable(String name, int type, String unit, String quantity, String displayUnit) {
      super(name, type, unit, quantity, displayUnit);
   }

// getValueAsList
    /** Gets the value as Set object */
    abstract public Set getValueAsSet ();


// Set interface implementation -----------------------------------------------------------------
// All requests are forwarded to the value set.
// In all methods which will change the value, a variableChange is signaled.

// no additional set operations - all inherited from CollectionVariable

}

