/*****************************************************************************
 *  Project: DEVSNeuron
 *  Description: discrete event-based simulation of spiking neural networks
 *  Filename: $RCSfile: CodingException.java,v $
 *  Author: Rene Mayrhofer
 *  Copyright: Rene Mayrhofer 2001
 *  Project version tag: $Name:  $
 *  File version: $Revision: 1.4 $
 *  Last changed at: $Date: 2002/05/16 20:43:26 $
 *  Last changed by: $Author: rene $
 *****************************************************************************/

package mosaic.sim.neuron;

/** This class represents an exception with the used spike coding. Whenever a situation is detected that is not allowed within the definition of the used coding scheme, this exception is thrown by the input or output converters. */
public class CodingException extends Exception {

    /** Creates a new CodingException with an error string.
	 *  @param s The error string stored in the exception.
	 */
	public CodingException(String s) {
		super(s);
	}
}
