/* Generated by Together */

package mosaic.sim.util.thread;


/** This interface specifies a way to pass an event object from outside the thread to
 *  a listner inside the thread of "this" class. */
public interface ThreadEventDispatcher {

    /** Adds a new EventWrapper to the event list and notifies the sleeping thread. */
    void add(EventWrapper ew);

    /** Implements an event loop, which loops all the time. */
    void eventLoop();

    /** Processes all events on the event list. */
    void processAll();

    /** Processes exactly one event object. Returns false if the event list was empty. */
    boolean processOne();

    /** Returns the current run mode. Used to control the eventLoop() method. */
    boolean isRun();

    /** Sets the current runmode. Used to control the eventLoop() method. */
    void setRun(boolean run);

    /** Sets the notify object, that will be notified when a new event is inserted. */
    void setNofiyObject(Object notifyObject);

    /** Returns false if new events are waiting for execution. */
    boolean isEmpty();

    /*#EventWrapper lnkEventWrapper;*/

}
