package mosaic.util;

import java.util.*;
import java.awt.*;
import javax.swing.*;

public class SimInformer extends Object {

    /** prints a class inheritance hierarchy for a given object */
    public static void printClassAndSuperClasses(Object obj) {
        int lvl;
        Class cur;

        lvl = 0;
        cur = obj.getClass();
        while (cur != null) {
            System.out.print ("|-");
            for (int i = 0; i < lvl; i++) {
                System.out.print("--");
            }
            lvl++;
            System.out.println ("" + cur);
            cur = cur.getSuperclass();
        }
    }

    /** prints infos about the component and all its parents */
    public static void printComponentTree(JComponent startingPoint) {
        Component cur;
        int level = 0;
        Vector  v = new Vector(10,5);
        cur = startingPoint;
        v.add(cur);
        while (cur.getParent() != null) {
            cur = cur.getParent();
            level++;
            v.add(cur);
        }

        for (curLevel = 0; curLevel <= level; curLevel++) {
            cur =(Component) v.elementAt(curLevel);
            newComp();
            newLine("a " + cur.getClass());
            newLine("  light   " + cur.isLightweight());
            newLine("  doubleB " + cur.isDoubleBuffered());
            newLine("  opaque  " + cur.isOpaque());
            newLine("  showing  " + cur.isShowing());
            if (cur instanceof JComponent) {
                JComponent jcur = (JComponent)cur;
                newLine("  joptDrawing  " + jcur.isOptimizedDrawingEnabled());
                newLine("  jpaintTile   " + jcur.isPaintingTile());
                newLine("  jvalidroot   " + jcur.isValidateRoot());
                newLine("  nOfChildren  " + (jcur.getComponents()).length);
                newLine("  RepMan        " + RepaintManager.currentManager(jcur).hashCode());
                newLine("  RM doubleBuff "+ RepaintManager.currentManager(jcur).isDoubleBufferingEnabled());
                newLine("  RM offscreenB "+ RepaintManager.currentManager(jcur).getOffscreenBuffer(jcur,10,10));

            }
        }
    }
        static int curLevel = 0;

    private static void newLine(Object out) {
        System.out.print("\n");
        for (int i = 0; i <= curLevel; i++) {
            System.out.print("  ");
        }
        System.out.print("| " + out);
    }

    private static void newComp() {
        System.out.print("\n");
        for (int i = 0; i <= curLevel; i++) {
            System.out.print("--");
        }
        System.out.print("| ");
    }

    //
    // Thread analysis
    //

    public static void printAllThreads() {
        ThreadGroup curG = Thread.currentThread().getThreadGroup();
        do {
            curG.list();
            curG = curG.getParent();
        } while (curG != null);
    }


}


