package mosaic.util.custom;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Simple Dialog with a component and an ok -Button to close.
 * <p>
 * Intended to show a customEditor of a PropertyEditor
 *
 * @version 17 Feb 1999
 * @author Thomas Hilpold
 */
public class CustomEditorDialog extends JDialog
    implements ActionListener {

    /** creates a container and an OK- Button*/
    public CustomEditorDialog(Component customEditor, String propertyName) {
        super(new JFrame(propertyName), true);
        this.setTitle(propertyName);
        this.setSize(new Dimension(300,300));
        this.customEditor = customEditor;
        getContentPane().setLayout(new BorderLayout());
        // "glue OK glue" in a horizontal Box
        buttonBox = Box.createHorizontalBox();
        buttonBox.add(Box.createHorizontalGlue());
        okButton = new JButton("OK");
        okButton.addActionListener(this);
        buttonBox.add(okButton);
        buttonBox.add(Box.createHorizontalGlue());
        getContentPane().add(buttonBox,"South");
        getContentPane().add(customEditor,"Center");
        this.pack();
    }

    /** closes the dialog, when OK - Button is pressed */
    public void actionPerformed (ActionEvent e) {
        setVisible(false);
    }

    private Component customEditor;
    private JButton okButton;
    private Box buttonBox;
}