package mosaic.util.custom;

import java.util.*;
import java.io.*;

/**
 * This Class extends the java.util.Vector by constructors,
 * which accept Object[] as initial Data to enable
 * visual editing and instantiation code generation by
 * the CustomVectorEditor.class. A componenttype can
 * be initially set as well.
 *
 * @version 17 Jan 1999
 * @author Thomas Hilpold
 */
public class CustomVector extends Vector {

    public CustomVector() {
        super();
        componentType = Object.class;
    }

    public CustomVector(int initSize) {
        super(initSize);
        componentType = Object.class;
    }

    public CustomVector(int initSize, Class componentType) {
        super(initSize);
        this.componentType = componentType;
    }

    /** initializes CustomVector with Objects, componenttype will be determined */
    public CustomVector(Object[] initV) {
        super(initV.length);
        this.componentType = initV.getClass().getComponentType();
        try {
            for (int i = 0; i < initV.length; i++) {
                //System.err.println("               try to add :" + initV[i]);
                this.addElement((initV[i]));
            }
        } catch (Exception e) {
            System.err.println("" + e);
        };
    }

    public Class getComponentType() {
        return componentType;
    }

    protected Class componentType;
}

