package mosaic.util.custom;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @version 17 Feb 1999
 * @author Thomas Hilpold
 */
public class RTPropertyDialog extends JDialog
    implements ActionListener {

    /** creates a container and an OK- Button*/
    public RTPropertyDialog(Object beanToEdit, Dialog parent, boolean modal) {
        super(parent, "", modal);
        init(beanToEdit);
    }

    public RTPropertyDialog(Object beanToEdit, Frame parent, boolean modal) {
        super(parent, "", modal);
        init(beanToEdit);
    }

    private void init(Object beanToEdit) {
        Component comp;

        setTitle(beanToEdit.getClass().getName());
        propSheet = new RTPropertySheet(beanToEdit);
        comp = propSheet.getScrollPane();
        getContentPane().setLayout(new BorderLayout());
        // "glue Close glue" in a horizontal Box
        buttonBox = Box.createHorizontalBox();
        buttonBox.add(Box.createHorizontalGlue());
        closeButton = new JButton("Close");
        closeButton.addActionListener(this);
        buttonBox.add(closeButton);
        buttonBox.add(Box.createHorizontalGlue());
        getContentPane().add(buttonBox,"South");
        getContentPane().add(comp,"Center");
        this.pack();
        setSize(new Dimension(300,200));
        this.setVisible(true);
    }

    public RTPropertyDialog(Object beanToEdit, boolean modal) {
        this(beanToEdit, (Frame)null, modal);
    }

    public RTPropertyDialog(Object beanToEdit) {
        this(beanToEdit, (Frame)null, false);
    }

    /** closes the dialog, when OK - Button is pressed */
    public void actionPerformed (ActionEvent e) {
        setVisible(false);
        propSheet = null;
        closeButton = null;
    }

    private RTPropertySheet propSheet;
    private JButton closeButton;
    private Box buttonBox;
}