package mosaic.vis.output;

import java.awt.*;
import javax.swing.*;
import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.*;

public class NumberWheelView extends WheelView implements VariableChangeListener {

    double currentValue = 0.0;
    //
    // Construction
    //

    public NumberWheelView() {
        this(3, 4, POINT_MODE, 15);
    }

    public NumberWheelView(int nrOfSpokes) {
        this(nrOfSpokes, 4, POINT_MODE, 15);
    }

    public NumberWheelView(int nrOfSpokes, int spokeWidth, int mode, double angleIncrement) {
        super(nrOfSpokes, spokeWidth, mode);
        setAngleIncrement(angleIncrement);
    }

    //
    // Property
    //

    //nomAngleIncrement

    private double nomAngleIncrement = 1.0f;

    public void setAngleIncrement(double a) {
        nomAngleIncrement = a;
    }

    public double getAngleIncrement() {
        return nomAngleIncrement;
    }

    //
    // Listening to a boolean variable
    //

    public void variableChange (VariableChangeEvent e) {
        super.variableChange(e);
        if (e.getValue() instanceof Number) {
            currentValue = ((Number)e.getValue()).doubleValue();
            isOn = (currentValue != 0.0);
            curAngleIncrement = currentValue * nomAngleIncrement;
        } else {
            System.err.println("Error in NumberWheelView: variableChange val: " + e.getValue());
        }
    }

    public void propertyChange (java.beans.PropertyChangeEvent e){};
    public void addListenerVariable (Variable v){
        getSimApplication().getAnimator().addView(this);
    };
    public void removeListenerVariable (Variable v){
        getSimApplication().getAnimator().removeView(this);
    };

}
