package mosaic.vis.output;

import java.awt.*;

public class PipeView extends ContVariableView {

  public final static boolean VERTICAL = false;
  public final static boolean HORIZONTAL = true;

    /** true...horizontal   false...vertical */
    boolean alignment = true;

    /**
       * Get the value of alignment.
       * @return Value of alignment.
       */
    public boolean getAlignment() {return alignment;}

    /**
       * Set the value of alignment.
       * @param v  Value to assign to alignment.
       */
    public void setAlignment(boolean  v) {this.alignment = v;}


    // Property flowColor
    Color flowColor = Color.blue;

    public void setFlowColor( Color c) {
        flowColor = c;
    }

    public Color getFlowColor () {
        return flowColor;
    }

    public void paintValue(Graphics g) {
        if (this.getDoubleValue() >0.01) { // draw pipe filled
            g.setColor(getFlowColor());
            g.fillRect(0,0,
                       getWidth(),(int)getHeight() );
        } else {
           g.setColor(getBackground());
           g.fillRect(0, 0, getWidth()-1, getHeight()-1 );
        }

        g.setColor(getForeground());
        g.drawRect(0,0, getWidth() - 1, getHeight() -1 );

    }

    /** Gets minimum size for the LayoutManager */
    public Dimension getMinimumSize() {
    	return new Dimension(1,1);
    }

    /** Gets preferred size for the LayoutManager */
    public Dimension getPreferredSize() {
    	return new Dimension(1,1);
    }
}
