
/**
 * Tachometer.java
 *
 *
 * Created: Fri Feb 11 18:02:20 2000
 *
 * @author Reitinger Bernhard
 * @version
 */
package mosaic.vis.output;

import java.awt.*;

public class Tachometer extends ContVariableView {
    
    
    private int compWidth = 128;
    private int compHeight = 128;
    // scale distance to border in percentage
    private float leftBorder = 0.05f; 
    private float topBorder = 0.10f;
    private float rightBorder = 0.05f;
    private float bottomBorder = 0.15f;
    private int angle = 180;
    // factor to scale the bigger circle-sector
    private float circleFactor = 0.2f; 
    private int nrOfTicks;
    private int nrOfLabels;
    private Image bgImage;
    private Pointer pointer;
    private Color bgColor = Color.black;
    private Color fgColor = Color.white;

    private int innerHeight = (int)(compHeight - (float)((float)compHeight*(float)(topBorder+bottomBorder)));
    private int innerWidth = (int)(compWidth - (float)((float)compWidth*(float)(leftBorder+rightBorder)));

    private float rad;
    private float s1x1, s1y1, s1x2, s1y2, s2x1, s2y1, s2x2, s2y2;
//     private float ;
//     private float ;
//     private float ;

    private void calcAll() {
	innerHeight = (int)(compHeight - (float)((float)compHeight*(float)(topBorder+bottomBorder)));
	innerWidth = (int)(compWidth - (float)((float)compWidth*(float)(leftBorder+rightBorder)));
// 	rad = (float)((float)innerHeight/(1.0-cutDownSector));
	rad = (float)(innerWidth/(2.0*Math.sin(Math.toRadians(angle/2.0))));
// 	s1x1 = (float)(compWidth/2.0-Math.sqrt(rad*rad-(rad*rad*rad*rad)/((innerWidth*innerWidth)/4+rad*rad)));
	s1x1 = (float)(compWidth*leftBorder);
	s1x2 = (float)(compWidth-2.0*s1x1);
 	s1y2 = (float)((innerWidth/2.0)*Math.tan(Math.toRadians(angle/4.0)));
	System.out.println("x1 "+s1x1+"    y2 "+s1y2);

	s2x2 = (float)(s1x2*circleFactor);
	s2y2 = (float)(s1y2*circleFactor);
	s2x1 = (float)(leftBorder*compWidth+(innerWidth*(1-circleFactor))/2.0);
	s2y1 = (float)(100);
    }
    
    /**
       * Get the value of fgColor.
       * @return Value of fgColor.
       */
    public Color getFgColor() {return fgColor;}
    
    /**
       * Set the value of fgColor.
       * @param v  Value to assign to fgColor.
       */
    public void setFgColor(Color  v) {this.fgColor = v;}
    
    
    /**
       * Get the value of bgColor.
       * @return Value of bgColor.
       */
    public Color getBgColor() {return bgColor;}
    
    /**
       * Set the value of bgColor.
       * @param v  Value to assign to bgColor.
       */
    public void setBgColor(Color  v) {this.bgColor = v;}
    
    
    /**
       * Get the value of pointer.
       * @return Value of pointer.
       */
    public Pointer getPointer() {return pointer;}
    
    /**
       * Set the value of pointer.
       * @param v  Value to assign to pointer.
       */
    public void setPointer(Pointer  v) {this.pointer = v;}
    
    
    /**
       * Get the value of bgImage.
       * @return Value of bgImage.
       */
    public Image getBgImage() {return bgImage;}
    
    /**
       * Set the value of bgImage.
       * @param v  Value to assign to bgImage.
       */
    public void setBgImage(Image  v) {this.bgImage = v;}

    
    /**
       * Get the value of nrOfLabels.
       * @return Value of nrOfLabels.
       */
    public int getNrOfLabels() {return nrOfLabels;}
    
    /**
       * Set the value of nrOfLabels.
       * @param v  Value to assign to nrOfLabels.
       */
    public void setNrOfLabels(int  v) {this.nrOfLabels = v;}

    
    /**
       * Get the value of nrOfTicks.
       * @return Value of nrOfTicks.
       */
    public int getNrOfTicks() {return nrOfTicks;}
    
    /**
       * Set the value of nrOfTicks.
       * @param v  Value to assign to nrOfTicks.
       */
    public void setNrOfTicks(int  v) {this.nrOfTicks = v;}
    
    
    /**
       * Get the value of circleFactor.
       * @return Value of circleFactor.
       */
    public float getCircleFactor() {return circleFactor;}
    
    /**
       * Set the value of circleFactor.
       * @param v  Value to assign to circleFactor.
       */
    public void setCircleFactor(float  v) {this.circleFactor = v;}
    
    
    /**
       * Get the value of angle.
       * @return Value of angle.
       */
    public int getAngle() {return angle;}
    
    /**
       * Set the value of angle.
       * @param v  Value to assign to angle.
       */
    public void setAngle(int  v) {this.angle = v;}
    
    
    /**
       * Get the value of bottomBorder.
       * @return Value of bottomBorder.
       */
    public float getBottomBorder() {return bottomBorder;}
    
    /**
       * Set the value of bottomBorder.
       * @param v  Value to assign to bottomBorder.
       */
    public void setBottomBorder(float  v) {
	this.bottomBorder = v;
	innerHeight = (int)(compHeight - (float)((float)compHeight*(float)(topBorder+bottomBorder)));
    }

    
    /**
       * Get the value of rightBorder.
       * @return Value of rightBorder.
       */
    public float getRightBorder() {return rightBorder;}
    
    /**
       * Set the value of rightBorder.
       * @param v  Value to assign to rightBorder.
       */
    public void setRightBorder(float  v) {
	this.rightBorder = v;
	innerWidth = (int)(compWidth - (float)((float)compWidth*(float)(leftBorder+rightBorder)));
    }
    
    
    /**
       * Get the value of topBorder.
       * @return Value of topBorder.
       */
    public float getTopBorder() {return topBorder;}
    
    /**
       * Set the value of topBorder.
       * @param v  Value to assign to topBorder.
       */
    public void setTopBorder(float  v) {
	this.topBorder = v;
	innerHeight = (int)(compHeight - (float)((float)compHeight*(float)(topBorder+bottomBorder)));
    }
    

    /**
       * Get the value of leftBorder.
       * @return Value of leftBorder.
       */
    public float getLeftBorder() {return leftBorder;}
    
    /**
       * Set the value of leftBorder.
       * @param v  Value to assign to leftBorder.
       */
    public void setLeftBorder(float  v) {
	this.leftBorder = v;
	innerWidth = (int)(compWidth - (float)((float)compWidth*(float)(leftBorder+rightBorder)));
    }
    
    
    /**
       * Get the value of compHeight.
       * @return Value of compHeight.
       */
    public int getCompHeight() {return compHeight;}
    
    /**
       * Set the value of compHeight.
       * @param v  Value to assign to compHeight.
       */
    public void setCompHeight(int  v) {
	this.compHeight = v;
	innerHeight = (int)(compHeight - (float)((float)compHeight*(float)(topBorder+bottomBorder)));
    }
    
    
    /**
       * Get the value of compWidth.
       * @return Value of compWidth.
       */
    public int getCompWidth() {return compWidth;}
    
    /**
       * Set the value of compWidth.
       * @param v  Value to assign to compWidth.
       */
    public void setCompWidth(int  v) {
	this.compWidth = v;
	innerWidth = (int)(compWidth - (float)((float)compWidth*(float)(leftBorder+rightBorder)));
    }
    
    
    public Tachometer() {
	setSize(compWidth, compHeight);
	calcAll();
    }

    //---------------paintValue---------------------------------------------------

    public void paintValue(Graphics g) {
	g.setColor(bgColor);
	g.fillRect(0, 0, getWidth()-1, getHeight()-1 );
	g.setColor(fgColor);
 	System.out.println(s1x1+"   "+s1y1+"   "+compWidth+"    "+rad);
// 	g.drawArc(compWidth-innerWidth/2,(int)(compHeight*topBorder+(float)(innerHeight*100.0/80.0))-40,50,50,10,160);//(int)innerWidth,(int)innerHeight,10,160);
	g.drawLine(0,(int)(compHeight*topBorder),compWidth,(int)(compHeight*topBorder));
	g.drawLine(0,(int)(compHeight-compHeight*topBorder),compWidth,(int)(compHeight-compHeight*topBorder));
	g.drawLine((int)(compWidth*leftBorder),0,(int)(compWidth*leftBorder),compHeight);
	g.drawLine((int)(compWidth-compWidth*leftBorder),0,(int)(compWidth-compWidth*leftBorder),compHeight);

	g.drawArc((int)s1x1,(int)(compHeight*topBorder),(int)s1x2,(int)s1y2,0,180);
	g.drawArc((int)s2x1,(int)s2y1,(int)s2x2,(int)s2y2,0,180);
// 	g.drawArc((int)s1x1,(int)(compHeight*topBorder),(int)s1x2,100,0,180);
	
    }

    public static void main(String[] args) {
	javax.swing.JFrame f = new javax.swing.JFrame();
	Tachometer t = new Tachometer();
	javax.swing.JPanel panel = new javax.swing.JPanel();

	panel.setLayout(null);
	t.setLocation(0,0);
	panel.add(t);
	f.getContentPane().add(t);
	f.setSize(200,200);
	f.setLocation(200,200);
	f.show();
    }

    
} // Tachometer

class Pointer {

    static Pointer instance = new Pointer();

    private Pointer() {
    }

    public Pointer getPointer() {
	return instance;
    }
}
